#include <TRandom.h> // use ROOT random generator
#include <TVector3.h>

#include <iostream>

int main() {
    // initialize random generator
    gRandom->SetSeed(time(nullptr));

    // MWDCb position is given
    double dcb_x = 1.0;
    double dcb_y = 2.0;

    // using GOOD data (with MWDCa), we can get some information
    double p0_x = 1.0;
    double p1_x = 2.0; // target_x = p0_x + dcb_x * p1_x
    double target_x_center = p0_x + dcb_x * p1_x;

    double p0_y = 1.0;
    double p1_y = 2.0; // target_y = p0_y + dcb_y * p1_y
    double target_y_center = p0_y + dcb_y * p1_y;

    double target_pos_sigma_x = 1.0; // assume constant
    double target_pos_sigma_y = 1.0; // assume constant
    // ====== if not constant ==========
    // double target_pos_sigma_x = get_sigma_x(dcb_x);
    // double target_pos_sigma_y = get_sigma_y(dcb_y);
    // =================================

    // assign target postion using gaussian random number
    double target_x = gRandom->Gaus(target_x_center, target_pos_sigma_x);
    double target_y = gRandom->Gaus(target_y_center, target_pos_sigma_y);

    std::cout << "MWDCb position         (x, y) = (" << dcb_x << ", " << dcb_y << ")" << std::endl;
    std::cout << "target position        (x, y) = (" << target_x_center << ", " << target_y_center << ")" << std::endl;
    std::cout << "target random position (x, y) = (" << target_x << ", " << target_y << ")" << std::endl;

    // some values
    double distance = 100.0; // distance between target and MWDCb
    TVector3 mwdcb_position(dcb_x, dcb_y, -distance);
    TVector3 target_position(target_x, target_y, 0.0); // z=0 target position
    TVector3 beam_direction = target_position - mwdcb_position;

    // calculate kinematics using this target_x and target_y

    return 0;
}
